module Atom (Atom,gensym,rename) where

import AbsM

data Atom = Atom Tag String 

instance Eq Atom where
    (Atom i _) == (Atom j _)     = i == j


instance Show (Atom) where
    showsPrec j (Atom i a)       =  showString "#" . 
				    showString a . 
				    showString "_" .
				    showsPrec j i

gensym 				 :: String -> AM Atom
gensym a			 =  new >>= \t -> 
				    return (Atom t a)

rename                           :: Atom -> AM Atom
rename (Atom _ a)                =  new >>= \t -> 
				    return (Atom t a)

