module AbsM (AM,Tag,(>>=),return,new,runAM) where

newtype Tag                      = Tag Int
				   deriving Eq

instance Show Tag where
    showsPrec i (Tag j) 	 = showsPrec i j

data AM a                        = AM(Int -> (a,Int))

instance Monad AM where
    AM(f) >>= g                  = AM(\i -> 
				      let (a,i') = f i in
				      let AM (g') = g a in
				      (g' i'))
    return a                     = AM (\i -> (a,i))

new                              :: AM Tag
new                              =  AM(\i -> (Tag i, i+1))
  
runAM                            :: AM a -> a
runAM (AM f)                     =  let (a,_) = f 0 in a

